#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#include "bd_string.h"

String::String()
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	setPascalString();
}

String::String(const String &copyMe)
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::String(const char copyMe[])
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::String(const unsigned char copyMe[])
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::String(char copyMe) 
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

/*String::String(unsigned char copyMe)
{
	shiftFiller=' ';
	cString=new char(NULL);
	*this=copyMe;
}*/

String::String(short copyMe)
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::String(long copyMe)
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::String(float copyMe)
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::String(unsigned short copyMe)
{
	shiftFiller=' ';
	cString=new char('\0');
	*this=copyMe;
}

String::String(unsigned long copyMe)
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::String(bool copyMe)
{
	shiftFiller=' ';
	cString=new char[1];
	cString[0]='\0';
	*this=copyMe;
}

String::~String()
{
	delete [] cString;
}

void String::setShiftFiller(char ShiftFiller)
{
	shiftFiller=ShiftFiller;
}

char String::getShiftFiller() const
{
	return shiftFiller;
}

const char *String::toCString() const
{
	return cString;
}

const unsigned char *String::toPascalString() const
{
	return pascalString;
}

char String::toChar() const
{
	return cString[0];
}

/*char String::toUnsignedChar() const
{
	return (unsigned char)cString[0];
}*/

bool String::toBool() const
{
	String tempString=cString;
	
	tempString=tempString.stripLeading();
	tempString=tempString.stripTrailing();
	
	if(tempString.toLower()=="false") return false;
	
	return true;
}

short String::toShort() const
{
	return atoi(cString);
}

long String::toLong() const
{
	return atol(cString);
}

float String::toFloat() const
{
	return float(atof(cString));
}

unsigned short String::toUnsignedShort() const
{
	return (unsigned short)toUnsignedLong();
}

unsigned long String::toUnsignedLong() const
{
	String temp=stripLeading().stripTrailing();
	unsigned long returnMe=0;
	
	for(long iter=0; temp.cString[iter]; iter++)
	{
		if(!isdigit(temp.cString[iter])) break;
		
		returnMe*=10;
		returnMe+=temp.cString[iter]-48;
	}
	
	return returnMe;
}

const String String::toUpper() const
{
	String returnMe;
	
	for(long iter=0; cString[iter]; iter++) returnMe+=char(toupper(cString[iter]));
	
	return returnMe;
}

const String String::toLower() const
{
	String returnMe;
	
	for(long iter=0; cString[iter]; iter++) returnMe+=char(tolower(cString[iter]));
	
	return returnMe;
}

const String String::stripLeading() const
{
	String returnMe=cString;
	
	while(isspace(returnMe.cString[0]) && returnMe.cString[0])
	{
		for(long iter=0; returnMe.cString[iter]; iter++) returnMe.cString[iter]=returnMe.cString[iter+1];
	}
	
	return returnMe;
}

const String String::stripTrailing() const
{
	String returnMe=cString;
	
	while(returnMe.cString[0] && isspace(returnMe.cString[strlen(returnMe.cString)-1])) returnMe.cString[strlen(returnMe.cString)-1]='\0';
	
	return returnMe;
}

unsigned long String::getLength() const
{
	return strlen(cString);
}

const String String::left(unsigned long len) const
{
	String returnMe;
	char tempChar;
	
	if(len>=strlen(cString)) return *this;
	
	if(len!=0)
	{
		tempChar=cString[len];
		cString[len]='\0';
		returnMe=cString;
		cString[len]=tempChar;
	}
	
	return returnMe;
}

const String String::right(unsigned long len) const
{
	if(len<strlen(cString)) return String(cString+strlen(cString)-len);
	
	return *this;
}

const String String::mid(unsigned long offset, unsigned long len) const
{
	String returnMe;
	char tempChar;
	
	if(offset>=strlen(cString) || len==0) return returnMe;
	
	tempChar=cString[offset+len];
	cString[offset+len]='\0';
	returnMe=cString+offset;
	cString[offset+len]=tempChar;
	
	return returnMe;
}

const String String::mid(unsigned long offset) const
{
	if(offset>=strlen(cString)) return String();
	
	return String(cString+offset);
}

long String::find(const String &findMe) const
{
	return find(findMe, 0);
}

long String::find(const String &findMe, unsigned long offset) const
{
	bool success;
	
	for(unsigned long iter1=offset; iter1<strlen(cString)-strlen(findMe.cString)+1; iter1++)
	{
		success=true;
		
		for(unsigned long iter2=0; iter2<strlen(findMe.cString); iter2++)
		{
			if(cString[iter1+iter2]!=findMe.cString[iter2])
			{
				success=false;
				break;
			}
		}
		
		if(success) return iter1;
	}
	
	return -1;
}

bool String::isAlpha() const
{
	for(long iter=0; cString[iter]; iter++) if(!isalpha(cString[iter])) return false;
	
	return true;
}

bool String::isNumber() const
{
	char *tempString=new char[strlen(cString)+1];
	bool success=true;
	bool decimal=false;
	
	if(*this=="") return false;
	
	strcpy(tempString, stripLeading().stripTrailing().cString);
	
	for(long iter=0; tempString[iter]; iter++)
	{
		if(!isdigit(tempString[iter]) && tempString[iter]!='.' || tempString[iter]=='.' && decimal)
		{
			success=false;
			break;
		}
		
		if(tempString[iter]=='.') decimal=true;
	}

	delete tempString;

	return success;
}

unsigned long String::getTokenCount() const
{
	return getTokenCount(" \t\r\n");
}

unsigned long String::getTokenCount(const String &delimiters) const
{
	long returnMe;
	unsigned long iter;
	
	for(returnMe=0, iter=0; cString[iter]; returnMe++)
	{
		for(; cString[iter] && strchr(delimiters.cString, cString[iter]); iter++);
		for(; cString[iter] && !strchr(delimiters.cString, cString[iter]); iter++);
		for(; cString[iter] && strchr(delimiters.cString, cString[iter]); iter++);
	}
	
	return returnMe;
}

String String::getToken(unsigned long offset) const
{
	return getToken(offset, " \t\r\n");
}

String String::getToken(unsigned long offset, const String &delimiters) const
{
	return getTokens(offset, 1, delimiters);
}

String String::getTokens(unsigned long offset, unsigned long amount) const
{
	return getTokens(offset, amount, " \t\r\n");
}

String String::getTokens(unsigned long offset, unsigned long amount, const String &delimiters) const
{
	unsigned long currTok;
	unsigned long iter;
	unsigned long tokStart;
	unsigned long tokEnd;
	
	for(currTok=0, iter=0; cString[iter] && currTok<(amount?offset+amount:currTok+1); currTok++)
	{
		for(; cString[iter] && strchr(delimiters.cString, cString[iter]); iter++);
		for(tokStart=(currTok<=offset?iter:tokStart); cString[iter] && !strchr(delimiters.cString, cString[iter]); iter++);
		for(tokEnd=iter; cString[iter] && strchr(delimiters.cString, cString[iter]); iter++);
	}
	
	return currTok<=offset?"":this->mid(tokStart, tokEnd-tokStart);
}

String String::flattenTokens()
{
	return flattenTokens(" \t\r\n");
}

String String::flattenTokens(const String &delimiters)
{
	String returnMe;
	
	returnMe=*this;
	
	if(returnMe.getTokenCount(delimiters)==1) return returnMe.getToken(0, delimiters);
	
	while(returnMe.getTokenCount(delimiters)>1) returnMe=returnMe.getToken(1, delimiters)+returnMe.getTokens(2, 0, delimiters);
	
	return returnMe;
}

const String &String::getLine(istream &inputStream, unsigned long maxChar)
{
	char *temp;
	
	temp=new char[maxChar];
	
	inputStream.getline(temp, maxChar);
	*this=temp;

	delete [] temp;
	
	return *this;
}
	
const String &String::readRaw(istream &inputStream, unsigned long maxChar)
{
	char *temp;
	
	temp=new char[maxChar];
	
	inputStream.read(temp, maxChar);
	*this=temp;

	delete [] temp;
	
	return *this;
}

void String::setPascalString()
{
	pascalString[0]=char(strlen(cString));
	for(long iter=0; cString[iter] && iter< 256; iter++) pascalString[iter+1]=cString[iter];
}

String String::operator<<(long offset) const
{
	String returnMe;
	char *temp;
	
	if(offset<0) return *this>>-offset;
	
	returnMe=mid(offset);
	temp=new char[offset+1];
	
	for(long iter=0; iter<offset; iter++) temp[iter]=shiftFiller;
	temp[offset]='\0';
	
	returnMe+=temp;
	
	return returnMe;
}

String String::operator>>(long offset) const
{
	String returnMe;
	char *temp;
	
	if(offset<0) return *this<<-offset;
	
	returnMe=left(strlen(cString)-offset);
	temp=new char[offset+1];
	
	for(long iter=0; iter<offset; iter++) temp[iter]=shiftFiller;
	temp[offset]='\0';
	
	returnMe=temp+returnMe;
	
	return returnMe;
}

const String &String::operator=(const String &assignMe)
{
	delete cString;
	cString=new char[strlen(assignMe.cString)+1];
	strcpy(cString, assignMe.cString);
	
	setPascalString();
	
	return *this;
}

const String &String::operator=(const char assignMe[])
{
	delete cString;
	cString=new char[strlen(assignMe)+1];
	strcpy(cString, assignMe);
	
	setPascalString();
	
	return *this;
}

const String &String::operator=(const unsigned char assignMe[])
{
	delete cString;
	cString=new char[assignMe[0]+1];
	
	for(long iter=0; iter<assignMe[0]; iter++) cString[iter]=assignMe[iter+1];
	
	cString[assignMe[0]+1]='\0';
	
	setPascalString();
	
	return *this;
}

const String &String::operator=(char assignMe)
{
	delete cString;
	cString=new char[2];
	cString[0]=assignMe;
	cString[1]='\0';
	
	setPascalString();
	
	return *this;
}


const String String::operator[](unsigned long offset) const
{
	return mid(offset, 1);
}

bool String::operator==(const String &contrastMe) const
{
	return strcmp(cString, contrastMe.cString)==0;
}

bool String::operator==(const char contrastMe[]) const
{
	return strcmp(cString, contrastMe)==0;
}

bool String::operator==(const unsigned char contrastMe[]) const
{
	for(long iter=0; iter<contrastMe[0]; iter++)
	{
		if((unsigned char)cString[iter]!=contrastMe[iter+1]) return false;
	}
	
	return true;
}

bool String::operator==(const char contrastMe) const
{
	if(!cString[0]) return !contrastMe;
	
	return !cString[1] && cString[0]==contrastMe;
}

/*bool String::operator==(unsigned char contrastMe) const
{
	if(cString[0]==NULL) return contrastMe==NULL;
	
	return cString[1]==NULL && (unsigned char)cString[0]==contrastMe;
}*/

bool String::operator!=(const String &contrastMe) const
{
	return strcmp(cString, contrastMe.cString)!=0;
}

bool String::operator!=(const char contrastMe[]) const
{
	return strcmp(cString, contrastMe)!=0;
}

bool String::operator!=(const unsigned char contrastMe[]) const
{
	for(long iter=0; iter<contrastMe[0]; iter++)
	{
		if((unsigned char)cString[iter]!=contrastMe[iter+1]) return true;
	}
	
	return false;
}

bool String::operator!=(char contrastMe) const
{
	if(cString[0]=='\0') return contrastMe!='\0';
	
	return cString[1] || cString[0]!=contrastMe;
}

/*bool String::operator!=(unsigned char contrastMe) const
{
	if(cString[0]==NULL) return contrastMe!=NULL;
	
	return cString[1]!=NULL || (unsigned char)cString[0]!=contrastMe;
}*/

bool String::operator>(const String &contrastMe) const
{
	return strcmp(cString, contrastMe.cString)>0;
}

bool String::operator>(const char contrastMe[]) const
{
	return strcmp(cString, contrastMe)>0;
}

bool String::operator>(const unsigned char contrastMe[]) const
{
	for(long iter=0; iter<contrastMe[0]; iter++)
	{
		if((unsigned char)cString[iter]<=contrastMe[iter+1]) return false;
	}
	
	return true;
}

bool String::operator>(char contrastMe) const
{
	if(strlen(cString)==0) return !contrastMe;
	
	return (unsigned char)cString[0]>(unsigned char)contrastMe || cString[0]==contrastMe && cString[1];
}

/*bool String::operator>(unsigned char contrastMe) const
{
	if(strlen(cString)==0) return contrastMe==NULL;
	
	return (unsigned char)cString[0]>contrastMe || cString[0]==contrastMe && cString[1]!=NULL;
}*/

bool String::operator<(const String &contrastMe) const
{
	return strcmp(cString, contrastMe.cString)<0;
}

bool String::operator<(const char contrastMe[]) const
{
	return strcmp(cString, contrastMe)<0;
}

bool String::operator<(const unsigned char contrastMe[]) const
{
	for(long iter=0; iter<contrastMe[0]; iter++)
	{
		if((unsigned char)cString[iter]>=contrastMe[iter+1]) return false;
	}
	
	return true;
}

bool String::operator<(char contrastMe) const
{
	return (unsigned char)cString[0]<(unsigned char)contrastMe;
}

/*bool String::operator<(unsigned char contrastMe) const
{
	return (unsigned char)cString[0]<contrastMe;
}*/

bool String::operator>=(const String &contrastMe) const
{
	return strcmp(cString, contrastMe.cString)>=0;
}

bool String::operator>=(const char contrastMe[]) const
{
	return strcmp(cString, contrastMe)>=0;
}

bool String::operator>=(const unsigned char contrastMe[]) const
{
	for(long iter=0; iter<contrastMe[0]; iter++)
	{
		if((unsigned char)cString[iter]<contrastMe[iter+1]) return false;
	}
	
	return true;
}

bool String::operator>=(char contrastMe) const
{
	return (unsigned char)cString[0]>=(unsigned char)contrastMe;
}

/*bool String::operator>=(unsigned char contrastMe) const
{
	return (unsigned char)cString[0]>=contrastMe;
}*/

bool String::operator<=(const String &contrastMe) const
{
	return strcmp(cString, contrastMe.cString)<=0;
}

bool String::operator<=(const char contrastMe[]) const
{
	return strcmp(cString, contrastMe)<=0;
}

bool String::operator<=(const unsigned char contrastMe[]) const
{
	for(long iter=0; iter<contrastMe[0]; iter++)
	{
		if((unsigned char)cString[iter]>contrastMe[iter+1]) return false;
	}
	
	return true;
}

bool String::operator<=(char contrastMe) const
{
	if(!cString[0]) return !contrastMe;
	
	return (unsigned char)cString[0]<(unsigned char)contrastMe || cString[0]==contrastMe && !cString[1];
}

/*bool String::operator<=(unsigned char contrastMe) const
{
	if(strlen(cString)==0) return !contrastMe;
	
	return (unsigned char)cString[0]<contrastMe || cString[0]==contrastMe && cString[1]==NULL;
}*/

const String &String::operator+=(const String &appendMe)
{
	*this=*this+appendMe;
	
	return *this;
}

const String &String::operator+=(const char appendMe[])
{
	*this=*this+appendMe;
	
	return *this;
}

const String &String::operator+=(const unsigned char appendMe[])
{
	*this=*this+appendMe;
	
	return *this;
}

const String &String::operator+=(const char appendMe)
{
	*this=*this+appendMe;
	
	return *this;
}

/*const String &String::operator+=(unsigned char appendMe)
{
	*this=*this+appendMe;
	
	return *this;
}*/

const String String::operator+(const String &appendMe) const
{
	char *temp=new char[strlen(cString)+strlen(appendMe.cString)+1];
	
	strcpy(temp, cString);
	strcat(temp, appendMe.cString);
	
	return String(temp);
}

const String String::operator+(const char appendMe[]) const
{
	char *temp=new char[strlen(cString)+strlen(appendMe)+1];
	
	strcpy(temp, cString);
	strcat(temp, appendMe);
	
	return String(temp);
}

const String String::operator+(const unsigned char appendMe[]) const
{
	String temp(appendMe);
	temp=*this+temp;
	
	return temp;
}

const String String::operator+(const char appendMe) const
{
	char *temp=new char[strlen(cString)+2];
	
	strcpy(temp, cString);
	temp[strlen(cString)]=appendMe;
	temp[strlen(cString)+1]='\0';
	
	return String(temp);
}

/*const String String::operator+(unsigned char appendMe) const
{
	char *temp=new char[strlen(cString)+2];
	
	strcpy(temp, cString);
	temp[strlen(cString)+1]=char(appendMe);
	temp[strlen(cString)+2]='\0';
	
	return String(temp);
}*/

const String &String::operator=(short assignMe)
{
	*this=short(assignMe);
	
	return *this;
}

const String &String::operator=(long assignMe)
{
	long noChars;
	long templong=assignMe;
	long currentChar;
	
	if(assignMe==0)
	{
		cString=new char[2];
		
		cString[0]='0';
		cString[1]='\0';
	}
	else
	{
		for(noChars=0; templong!=0; noChars++, templong/=10)
		{
		}
		
		if(assignMe<0) noChars++;
		
		cString=new char[noChars+1];
		
		if(assignMe<0)
		{
			cString[0]='-';
			assignMe=-assignMe;
		}
		
		for(templong=assignMe%10, currentChar=noChars-1; assignMe!=0; assignMe/=10, templong=assignMe%10, currentChar--) cString[currentChar]=char(templong+48);
		
		cString[noChars]='\0';
	}
	
	setPascalString();
	
	return *this;
}

const String &String::operator=(float assignMe)
{
	long decimalLength;
	long currChar;
	float temp=assignMe-long(assignMe);
	char *buffer;
	
	*this=long(assignMe);
	
	if(long(assignMe)!=assignMe)
	{
		for(decimalLength=1, temp*=10; temp==long(temp); decimalLength++, temp*=10)
		{
		}
		
		currChar=strlen(cString);
		
		buffer=new char[currChar+decimalLength+2];
		strcpy(buffer, cString);
		
		buffer[currChar]='.';
		
		for(currChar+=1; long(assignMe)!=assignMe; currChar++)
		{
			assignMe*=10;
			buffer[currChar]=char(assignMe+48);
		}
		
		buffer[currChar]='\0';
		
		*this=buffer;
		
		delete buffer;
	}
	
	setPascalString();
	
	return *this;
}

const String &String::operator=(unsigned short assignMe)
{
	*this=(unsigned long)assignMe;
	
	return *this;
}

const String &String::operator=(unsigned long assignMe)
{
	long noChars;
	long templong=assignMe;
	long currentChar;
	
	if(assignMe==0)
	{
		cString=new char[2];
		
		cString[0]='0';
		cString[1]='\0';
	}
	else
	{
		for(noChars=0; templong!=0; noChars++, templong/=10)
		{
		}
		
		cString=new char[noChars+1];
		
		for(templong=assignMe%10, currentChar=noChars-1; assignMe!=0; assignMe/=10, templong=assignMe%10, currentChar--) cString[currentChar]=char(templong+48);
		
		cString[noChars]='\0';
	}
	
	setPascalString();
	
	return *this;
}

const String &String::operator=(bool assignMe)
{
	if(assignMe)
	{
		cString=new char[5];
		strcpy(cString, "true");
	}
	else
	{
		cString=new char[6];
		strcpy(cString, "false");
	}
	
	setPascalString();
	
	return *this;
}

bool operator==(const char charArrayParam[], const String &stringParam)
{
	return stringParam==charArrayParam;
}

bool operator==(const unsigned char charArrayParam[], const String &stringParam)
{
	return stringParam==charArrayParam;
}

bool operator==(char charParam, const String &stringParam)
{
	return stringParam==charParam;
}

/*bool operator==(unsigned char charParam, const String &stringParam)
{
	return stringParam==charParam;
}*/

bool operator!=(const char charArrayParam[], const String &stringParam)
{
	return stringParam!=charArrayParam;
}

bool operator!=(const unsigned char charArrayParam[], const String &stringParam)
{
	return stringParam!=charArrayParam;
}

bool operator!=(char charParam, const String &stringParam)
{
	return stringParam!=charParam;
}

/*bool operator!=(unsigned char charParam, const String &stringParam)
{
	return stringParam!=charParam;
}*/

bool operator>(const char charArrayParam[], const String &stringParam)
{
	return stringParam<charArrayParam;
}

bool operator>(const unsigned char charArrayParam[], const String &stringParam)
{
	return stringParam!=charArrayParam;
}

bool operator>(char charParam, const String &stringParam)
{
	return stringParam<charParam;
}

/*bool operator>(unsigned char charParam, const String &stringParam)
{
	return stringParam<charParam;
}*/

bool operator<(const char charArrayParam[], const String &stringParam)
{
	return stringParam>charArrayParam;
}

bool operator<(const unsigned char charArrayParam[], const String &stringParam)
{
	return stringParam>charArrayParam;
}

bool operator<(char charParam, const String &stringParam)
{
	return stringParam>charParam;
}

/*bool operator<(unsigned char charParam, const String &stringParam)
{
	return stringParam>charParam;
}*/

bool operator>=(const char charArrayParam[], const String &stringParam)
{
	return stringParam<=charArrayParam;
}

bool operator>=(const unsigned char charArrayParam[], const String &stringParam)
{
	return stringParam<=charArrayParam;
}

bool operator>=(char charParam, const String &stringParam)
{
	return stringParam<=charParam;
}

/*bool operator>=(unsigned char charParam, const String &stringParam) 
{
	return stringParam<=charParam;
}*/

bool operator<=(const char charArrayParam[], const String &stringParam)
{
	return stringParam>=charArrayParam;
}

bool operator<=(const unsigned char charArrayParam[], const String &stringParam)
{
	return stringParam>=charArrayParam;
}

bool operator<=(char charParam, const String &stringParam)
{
	return stringParam>=charParam;
}

/*bool operator<=(unsigned char charParam, const String &stringParam)
{
	return stringParam>=charParam;
}*/

const String operator+(const char charArrayParam[], const String &stringParam)
{
	return String(charArrayParam)+stringParam;
}

const String operator+(const unsigned char charArrayParam[], const String &stringParam)
{
	return String(charArrayParam)+stringParam;
}

const String operator+(char charParam, const String &stringParam)
{
	return String(charParam)+stringParam;
}

/*const String operator+(unsigned char charParam, const String &stringParam)
{
	return String(charParam)+stringParam;
}*/

ostream &operator<<(ostream &out, const String &outputMe)
{
	out << outputMe.toCString();
	
	return out;
}
