#include <iostream.h>
#include <stdlib.h>

#include "break.h"
#include "square.h"
#include "board.h"

Board::Board()
{
	int iter1;
	int iter2;
	
	int curr;
	
	totalMoves=0;
	totalCommited=0;
	
	for(iter1=0; iter1<COLS; iter1++)
	{
		for(iter2=0; iter2<ROWS; iter2++) squares[iter1][iter2]=sqEmpty;
		
		colFill[iter1]=5;
	}
	
	for(iter1=0; iter1<COLS; iter1++) squares[iter1][ROWS]=sqNull;
	
	curr=0;
	
	for(iter1=0; iter1<COLS-3; iter1++)
	{
		for(iter2=0; iter2<ROWS; iter2++)
		{
			rows[curr][0]=&squares[iter1][iter2];
			rows[curr][1]=&squares[iter1+1][iter2];
			rows[curr][2]=&squares[iter1+2][iter2];
			rows[curr][3]=&squares[iter1+3][iter2];
			
			lowerRows[curr][0]=&squares[iter1][iter2+1];
			lowerRows[curr][1]=&squares[iter1+1][iter2+1];
			lowerRows[curr][2]=&squares[iter1+2][iter2+1];
			lowerRows[curr][3]=&squares[iter1+3][iter2+1];
			
			curr++;
		}
	}
	
	curr=0;
	
	for(iter1=0; iter1<COLS-3; iter1++)
	{
		for(iter2=0; iter2<ROWS-3; iter2++)
		{
			diags[curr][0]=&squares[iter1][iter2];
			diags[curr][1]=&squares[iter1+1][iter2+1];
			diags[curr][2]=&squares[iter1+2][iter2+2];
			diags[curr][3]=&squares[iter1+3][iter2+3];
			
			lowerDiags[curr][0]=&squares[iter1][iter2+1];
			lowerDiags[curr][1]=&squares[iter1+1][iter2+2];
			lowerDiags[curr][2]=&squares[iter1+2][iter2+3];
			lowerDiags[curr][3]=&squares[iter1+3][iter2+4];
			
			curr++;
			
			diags[curr][0]=&squares[iter1][iter2+3];
			diags[curr][1]=&squares[iter1+1][iter2+2];
			diags[curr][2]=&squares[iter1+2][iter2+1];
			diags[curr][3]=&squares[iter1+3][iter2];
			
			lowerDiags[curr][0]=&squares[iter1][iter2+4];
			lowerDiags[curr][1]=&squares[iter1+1][iter2+3];
			lowerDiags[curr][2]=&squares[iter1+2][iter2+2];
			lowerDiags[curr][3]=&squares[iter1+3][iter2+1];
			
			curr++;
		}
	}
	
	curr=0;
	
	for(iter1=0; iter1<COLS; iter1++)
	{
		for(iter2=0; iter2<ROWS-3 ; iter2++)
		{
			cols[curr][0]=&squares[iter1][iter2];
			cols[curr][1]=&squares[iter1][iter2+1];
			cols[curr][2]=&squares[iter1][iter2+2];
			cols[curr][3]=&squares[iter1][iter2+3];
			
			curr++;
		}
	}
}

Board *Board::instance=NULL;

void Board::display()
{
	int iter1;
	int iter2;
	
	for(iter1=0; iter1<COLS; iter1++) cout << "  " << iter1 << ' ';
	cout << BREAK << endl;
	
	for(iter2=0; iter2<ROWS; iter2++)
	{
		for(iter1=0; iter1<COLS; iter1++) cout << "+---";
		cout << '+' << BREAK << endl;
		
		for(iter1=0; iter1<COLS; iter1++) cout << "| " << ((squares[iter1][iter2]==sqWhite)?'O':(squares[iter1][iter2]==sqBlack)?'*':' ')<< ' ';
		cout << "|" << BREAK << endl;
	}
	
	for(iter1=0; iter1<COLS; iter1++) cout << "+---";
	cout << '+' << BREAK << endl;
	
	for(iter1=0; iter1<COLS; iter1++) cout << "  " << iter1 << ' ';
	cout << BREAK << endl;
}

void Board::commit()
{
	totalCommited=totalMoves;
}
